if (heapSize < 20000000) then
	heapSize = 200000000

fname = getOpenFileName \
caption:"Rusty Hearts Model File" \
types:"Rusty Hearts Model File(*.mgm)|*.mgm" \
historyCategory:"Rusty Hearts Object Presets"
f = fopen fname "rb"

fn PrintOffset Var =
(
	local Var = Var
print ("This is the offset 0x" + (bit.intAsHex Var) as string)
	Var
)
fn PrintCount Var =
(
	local Var = Var
print ("This is the Count 0x" + (bit.intAsHex Var) as string)
	Var
)

fn Readword fstream = (
return readshort fstream #unsigned
)

fn ReadFixedString bstream fixedLen =
(
	local str = ""
	for i = 1 to fixedLen do
	(
		str += bit.intAsChar (ReadByte bstream #unsigned)
	)
	str
)
fn ReadFixedUString bstream fixedLen =
(
	local str = ""
	for i = 1 to fixedLen do
	(
		str += bit.intAsChar (ReadByte bstream #unsigned)
		null = (ReadByte bstream #unsigned)
	)
	str
)

struct bone_Info_Struct
(
	b1,b2,b3,b4
)
struct weight_Info_Struct
(
	w1,w2,w3,w4
)
struct weight_data
(
	boneids,weights
)
DoBal = ReadFixedString f 5
Count1 = readlong f
Count2 = readlong f
--offset
Array_1 = #()
for a = 1 to Count2 Do (
append Array_1 (readlong f)
)
--size
Array_2 = #()
for a = 1 to Count2 Do (
append Array_2 (readlong f)
)
--type
Array_3 = #()
for a = 1 to Count2 Do (
append Array_3 (readlong f)
)

for a = 1 to Count2 Do (
print ((bit.intashex Array_1[a]) + " , " + (bit.intashex Array_2[a]) + " , " + Array_3[a] as string)
)
BNArr = #()
BNArr2 = #()
for a = 1 to Count2 Do (
case of (
	
(Array_3[a] == 2):(
fseek f Array_1[a]#seek_set
BoneNameSize = readlong f
BoneParentNameSize = readlong f
BoneNameHash = readlong f
BoneParentNameHash = readlong f
BoneName = ReadFixedUString f BoneNameSize
BoneParentName = ReadFixedUString f BoneParentNameSize
append BNArr2 BoneName
)
	
(Array_3[a] == 3):(
fseek f Array_1[a]#seek_set
BoneNameSize = readlong f
BoneParentNameSize = readlong f
BoneNameSize1 = readlong f
BoneNameHash = readlong f
BoneParentNameHash = readlong f
BoneNameHash1 = readlong f
BoneName = ReadFixedUString f BoneNameSize
BoneParentName = ReadFixedUString f BoneParentNameSize
BoneName1 = ReadFixedUString f BoneNameSize1
if isvalidnode (getNodeByName BoneName) == true then (
append BNArr (getNodeByName BoneName)
)
if isvalidnode (getNodeByName BoneName) != true then (

test = (Array_2[a] - (0x100 + (BoneNameSize * 2) + (BoneNameSize1 * 2) + (BoneParentNameSize * 2)))
fseek f test#seek_cur
print (BoneName + " , " + BoneParentName)
	--Absolute Matrix
m11 = readfloat f; m12 = readfloat f; m13 = readfloat f; m14 = readfloat f
m21 = readfloat f; m22 = readfloat f; m23 = readfloat f; m24 = readfloat f
m31 = readfloat f; m32 = readfloat f; m33 = readfloat f; m34 = readfloat f
m41 = readfloat f; m42 = readfloat f; m43 = readfloat f; m44 = readfloat f
tfm = matrix3 [m11,m12,m13] [m21,m22,m23] [m31,m32,m33] [m41,m42,m43]
-- Inverse Matrix
m11 = readfloat f; m12 = readfloat f; m13 = readfloat f; m14 = readfloat f
m21 = readfloat f; m22 = readfloat f; m23 = readfloat f; m24 = readfloat f
m31 = readfloat f; m32 = readfloat f; m33 = readfloat f; m34 = readfloat f
m41 = readfloat f; m42 = readfloat f; m43 = readfloat f; m44 = readfloat f
tfm2 = matrix3 [m11,m12,m13] [m21,m22,m23] [m31,m32,m33] [m41,m42,m43]	
--Relative Matrix
m11 = readfloat f; m12 = readfloat f; m13 = readfloat f; m14 = readfloat f
m21 = readfloat f; m22 = readfloat f; m23 = readfloat f; m24 = readfloat f
m31 = readfloat f; m32 = readfloat f; m33 = readfloat f; m34 = readfloat f
m41 = readfloat f; m42 = readfloat f; m43 = readfloat f; m44 = readfloat f
tfm3 = matrix3 [m11,m12,m13] [m21,m22,m23] [m31,m32,m33] [m41,m42,m43]
--Relative Matrix Seperated
PosX = readfloat f;PosY = readfloat f;PosZ = readfloat f
Quatx = readfloat f;Quaty = readfloat f;Quatz = readfloat f;Quatw = readfloat f
ScaleX = readfloat f;ScaleY = readfloat f;ScaleZ = readfloat f

newBone = bonesys.createbone	\
				  tfm.row4	\
				  (tfm.row4 + 0.01 * (normalize tfm.row1)) \
				  (normalize tfm.row3)
			newBone.name = BoneName
			newBone.width  = 0.01
			newBone.height = 0.01
			newBone.transform = tfm
			newBone.setBoneEnable false 0
			newBone.wirecolor = yellow
			newbone.showlinks = true
			newBone.pos.controller      = TCB_position ()
			newBone.rotation.controller = TCB_rotation ()
	
 if (BoneParentNameSize != 0) then
 newBone.parent = getnodebyname BoneParentName
append BNArr newBone	
				  )
)

(Array_3[a] == 6):(
fseek f Array_1[a]#seek_set
print ("Mesh Found at " + bit.intashex (ftell f))
MeshName1Size = readlong f
MeshName2Size = readlong f
unk01 = readlong f
unk02 = readlong f
MeshName1 = ReadFixedUString f MeshName1Size
MeshName2 = ReadFixedUString f MeshName2Size
print MeshName1
print MeshName2
MeshCount = readlong f
for c = 1 to MeshCount Do (
MatNameSize = readlong f
MatName = ReadFixedUString f MatNameSize
print MatName
VertCount = readlong f
FaceCount = readlong f
fseek f 0xF#seek_cur
MeshType = readlong f
Vert_array = #()
Normal_array = #()
UV_array = #()
Face_array = #()
Weight_array = #()
WeightID_array = #()
BoneID_array = #()
used_id_array = #()
for b = 1 to VertCount Do (
vx = readfloat f
vy = readfloat f
vz = readfloat f
nx = readfloat f
ny = readfloat f
nz = readfloat f
tu = readfloat f
tv = readfloat f * -1
append Vert_array [vx,vy,vz]
append Normal_array [nx,ny,nz]
append UV_array [tu,tv,0]
)
for b = 1 to FaceCount Do (
f1 = ((readshort f) + 1)
f2 = ((readshort f) + 1)
f3 = ((readshort f) + 1)
append Face_array [f1,f3,f2] --save faces to Face_array
)
x = 1
case of (
(MeshType == 1):(
for b = 1 to VertCount Do (
b1 = ((readshort f#unsigned) + x)
b2 = 0
b3 = 0
b4 = 0
appendIfUnique used_id_array (b1)
append BoneID_array (bone_Info_Struct b1:b1 b2:b2 b3:b3 b4:b4)
)
for b = 1 to VertCount Do (
w1 = readfloat f
w2 = 0
w3 = 0
w4 = 0
append WeightID_array (weight_Info_Struct w1:w1 w2:w2 w3:w3 w4:w4)
)
)
(MeshType == 2):(
for b = 1 to VertCount Do (
b1 = ((readshort f#unsigned) + x)
b2 = ((readshort f#unsigned) + x)
b3 = 0
b4 = 0
appendIfUnique used_id_array (b1)
appendIfUnique used_id_array (b2)
append BoneID_array (bone_Info_Struct b1:b1 b2:b2 b3:b3 b4:b4)
)
for b = 1 to VertCount Do (
w1 = readfloat f
w2 = readfloat f
w3 = 0
w4 = 0
append WeightID_array (weight_Info_Struct w1:w1 w2:w2 w3:w3 w4:w4)
)
)
(MeshType == 3):(
for b = 1 to VertCount Do (
b1 = ((readshort f#unsigned) + x)
b2 = ((readshort f#unsigned) + x)
b3 = ((readshort f#unsigned) + x)
b4 = 0
appendIfUnique used_id_array (b1)
appendIfUnique used_id_array (b2)
appendIfUnique used_id_array (b3)
append BoneID_array (bone_Info_Struct b1:b1 b2:b2 b3:b3 b4:b4)
)
for b = 1 to VertCount Do (
w1 = readfloat f
w2 = readfloat f
w3 = readfloat f
w4 = 0
append WeightID_array (weight_Info_Struct w1:w1 w2:w2 w3:w3 w4:w4)
)
)
(MeshType == 4):(
for b = 1 to VertCount Do (
b1 = ((readshort f#unsigned) + x)
b2 = ((readshort f#unsigned) + x)
b3 = ((readshort f#unsigned) + x)
b4 = ((readshort f#unsigned) + x)
appendIfUnique used_id_array (b1)
appendIfUnique used_id_array (b2)
appendIfUnique used_id_array (b3)
appendIfUnique used_id_array (b4)
append BoneID_array (bone_Info_Struct b1:b1 b2:b2 b3:b3 b4:b4)
)
for b = 1 to VertCount Do (
w1 = readfloat f
w2 = readfloat f
w3 = readfloat f
w4 = readfloat f
append WeightID_array (weight_Info_Struct w1:w1 w2:w2 w3:w3 w4:w4)
)
)

)

for i = 1 to VertCount Do (
w = (weight_data boneids:#() weights:#())
maxweight = 0
if(WeightID_array[i].w1 != 0) then
	maxweight = maxweight + WeightID_array[i].w1
if(WeightID_array[i].w2 != 0) then
	maxweight = maxweight + WeightID_array[i].w2
if(WeightID_array[i].w3 != 0) then
	maxweight = maxweight + WeightID_array[i].w3
if(WeightID_array[i].w4 != 0) then
	maxweight = maxweight + WeightID_array[i].w4

if(maxweight != 0) then (
		if(WeightID_array[i].w1 != 0) then (
			append w.boneids (BoneID_array[i].b1)
			append w.weights WeightID_array[i].w1
		)
		if(WeightID_array[i].w2 != 0) then (
			append w.boneids (BoneID_array[i].b2)
			append w.weights WeightID_array[i].w2
		)
		if(WeightID_array[i].w3 != 0) then (
			append w.boneids (BoneID_array[i].b3)
			append w.weights WeightID_array[i].w3
		)
		if(WeightID_array[i].w4 != 0) then (
			append w.boneids (BoneID_array[i].b4)
			append w.weights WeightID_array[i].w4
		)		
	)
append Weight_array w	
)

msh = mesh vertices:Vert_array faces:Face_array
msh.numTVerts = UV_array.count
buildTVFaces msh
--msh.material = 
msh.name = MeshType as string
for j = 1 to UV_array.count do setTVert msh j UV_array[j]
for j = 1 to Face_array.count do setTVFace msh j Face_array[j]
for j = 1 to Normal_array.count do setNormal msh j Normal_array[j]
	

max modify mode
select msh
skinMod = skin ()
addModifier msh skinMod
for i = 1 to used_id_array.count do
(
	maxbone = getnodebyname BNArr2[(used_id_array[i])]
	if i != used_id_array.count then
		skinOps.addBone skinMod maxbone 0
	else
		skinOps.addBone skinMod maxbone 1
)
modPanel.setCurrentObject skinMod

for i = 1 to Weight_array.count do
(
	w = Weight_array[i]
	bi = #()
	wv = #()
	for j = 1 to w.boneids.count do
	(
		boneid = (finditem used_id_array w.boneids[j])
		weight = w.weights[j]
		append bi boneid
		append wv weight
	)	
	skinops.setvertexweights skinMod i bi wv
)

max create mode
)
)
	
default:(

)	

	
)
)
print BNArr.count
fclose f